/*  selectwm - X11 window manager selector
 *
 *  Copyright (C) 1999  Luc Dufresne - ldufresne@altern.org
 *                      26, rue des Comices
 *                      59650 Villeneuve d'Ascq
 *                      FRANCE
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See the file COPYING
 */


#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

GString *getline(FILE *fichier)
{
	GString *temp;
	gchar buf[128];
	
	temp=g_string_new("");
	do
	{
		fgets(buf,sizeof(buf),fichier);
		g_string_append(temp,buf);
		if(feof(fichier))return temp;
	}while(strstr(buf,"\n")==NULL);
	return temp;
}

void read_config(GtkWidget *list)
{
	FILE *config;
	GString *buf,*buf2,*buf3;
	gchar *c,*text[1];
	gint row;
	
	buf=g_string_new("");
	g_string_sprintf(buf,"%s/.selectwmrc",getenv("HOME"));
	config=fopen(buf->str,"rt");
	g_string_free(buf,TRUE);
	if(!config)return;
	while(!feof(config))
	{
		buf=getline(config);
                if(feof(config))
		{
			fclose(config);
			g_string_free(buf,TRUE);
			return;
		}
		if(buf->str[0]!='#')
		{
			buf2=g_string_new("");
			c=buf->str;
			while(*c!='=' && *c!='\n')
			{
				g_string_append_c(buf2,*c);
				c++;
			}
			if(*c!='\n')
			{
				c++;
				buf3=g_string_new("");
				while(*c!='\n')
				{
					g_string_append_c(buf3,*c);
					c++;
				}
				text[0]=buf2->str;
				row=gtk_clist_append(GTK_CLIST(list),text);
				gtk_clist_set_row_data(GTK_CLIST(list),row,buf3->str);
			}
			g_string_free(buf2,TRUE);
		}
		g_string_free(buf,TRUE);
	}
	fclose(config);
}

void list_callback ( GtkWidget *clist, gint row, gint column,
                GdkEventButton *event, gpointer data)
{
	gchar *cmd;

	cmd=(gchar *)gtk_clist_get_row_data(GTK_CLIST(clist),row);
	execlp(cmd,cmd,NULL);
}

gint main(gint argc, gchar *argv[])
{
	GtkWidget *window,*scroll,*list;
	
	gtk_init (&argc, &argv);
	
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect (GTK_OBJECT (window), "destroy",GTK_SIGNAL_FUNC(gtk_main_quit),&window);

	gtk_container_set_border_width (GTK_CONTAINER (window), 2);
	gtk_widget_set_usize (window, 130, 150);
	gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
	
	scroll = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll),
				  GTK_POLICY_AUTOMATIC,
				  GTK_POLICY_AUTOMATIC);

	gtk_container_add (GTK_CONTAINER(window), scroll);
	gtk_widget_show (scroll);

	list = gtk_clist_new(1);
	gtk_clist_set_selection_mode(GTK_CLIST(list),GTK_SELECTION_SINGLE);
	gtk_clist_set_shadow_type(GTK_CLIST(list),GTK_SHADOW_NONE);

	gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scroll), list);
	
	read_config(list);
	gtk_signal_connect(GTK_OBJECT(list),"select_row",GTK_SIGNAL_FUNC(list_callback),NULL);
	gtk_widget_show (list);

	gtk_widget_show(window);

	gtk_main();
	return 0;
}
